#coding=utf8

# This file is part of CloudControl.
#
# CloudControl is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CloudControl is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with CloudControl.  If not, see <http://www.gnu.org/licenses/>.

'''
CloudControl attachment command
'''

import os
import subprocess

from cccli.exception import *
from cccli.command import TqlCommand

class Command_attachment(TqlCommand):
    '''Retrieve an attachment'''

    def __init__(self, cli, argv0):
        TqlCommand.__init__(self, cli, argv0)
        self.set_usage("%prog [options] <tql> attachment [attachment] ...")
        self.tql_filter += "&r=job"

    def __call__(self, argv):
        # Parse argline
        self.parse_args(argv)
        # append current login if nothing asked
        if len(self.args) != 2:
            raise cmdBadArgument()
        # ask server
        objs = self.rpc.call("attachment", self.args[0], self.args[1])
        for out in objs['objects']:
            if out['status'] == 'success':
                self.printer.pager(out['output'])
            else:
                self.printer.warn('%s: %s' % (out['id'], out['message']))

    def remote_functions(self):
        return set(("attachment",))
